local AddonName, NAlert = ...
local NAS

NAlert.LogFrame = CreateFrame("Frame" , "NAlertLogFrame", UIParent )
local me = NAlert.LogFrame
me:SetFrameStrata("DIALOG")
me:Hide()
me:RegisterEvent("ADDON_LOADED")

local MOBuff = 5 -- Mouse Over Pixel Buffer
local e = 0 -- elapsed time counter
local cdown = 0 -- auto cancel countdown
local fdelay = 0 -- Fade Countdown

local TxtFrmWidthOffset = 16
local TxtFrmTopOffset = -16
local TxtFrmBottomOffset = 40
local TxtFrmMaxLines = 128
local TextFrameMultiInset = 5
local TFrgb = { 255, 255, 255 }

local update= 1/10
local Backdrop={
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0
	}
}
	
me:EnableMouse(true)
me:SetPoint("CENTER", UIParent, "CENTER")
me:SetHeight( 250 )
me:SetWidth( 450 )
me:SetBackdrop( Backdrop )
me:SetBackdropColor( 128, 128,128, 1)
me:SetBackdropBorderColor( 255, 255, 255, 1)
me:SetMovable(true)
me:SetUserPlaced(true)
me:SetClampedToScreen(true)

NAlert.ScrollingMessageFrame = CreateFrame( "ScrollingMessageFrame", "NAlertLogScrollingMessageFrame", me)
local TextFrame = NAlert.ScrollingMessageFrame
TextFrame:SetPoint("LEFT", me, "LEFT", TxtFrmWidthOffset,0)
TextFrame:SetPoint("RIGHT", me, "RIGHT", (-TxtFrmWidthOffset),0)
TextFrame:SetPoint("TOP", me, "TOP", 0, TxtFrmTopOffset)
TextFrame:SetPoint("BOTTOM", me, "BOTTOM", 0, TxtFrmBottomOffset)
TextFrame:EnableMouse( true )
TextFrame:EnableMouseWheel( true )
TextFrame:SetHyperlinksEnabled(true)
TextFrame:SetJustifyH( "LEFT" )
TextFrame:SetJustifyV( "MIDDLE" )
TextFrame:SetFading( false )
TextFrame:SetMaxLines( 256 )
TextFrame:SetFontObject("GameFontNormal")
TextFrame:Raise()
TextFrame:SetIndentedWordWrap(true)

TextFrame:SetScript("OnHyperlinkClick", function(self, linkData, link, button)
	if button ~= "LeftButton" then
		return
	end
	SetItemRef(link)
	return
end)

TextFrame:SetScript("OnMouseWheel", function(self, delta)
	local c = 0
	repeat
		if delta > 0 then -- move list up 
			TextFrame:ScrollUp()
		elseif delta < 0 then -- move list down
			TextFrame:ScrollDown()
		end
		if c > 0 or IsShiftKeyDown() then
			c = c + 1
		end
	until c == 0 or c == 5
	
	return
end)

me:SetScript("OnEvent",function(self, event, ...)
	if event == "ADDON_LOADED" then
		local arg = ...
		if arg == AddonName then
			NAS = NAlert.Settings
			if NAS.Log and NAS.LogShow then
				NAlert.LogShown = true
				me:Show()
			else
				NAlert.LogShown = false
				me:Hide()
			end
			TextFrame:SetFont( STANDARD_TEXT_FONT, NAS.FontSize)
			me:SetScale(NAS.MFScale / 100)
		end
	end
end)

me:SetScript("OnShow", function(self)
	NAlert.LogFrame:SetScale(NAS.MFScale / 100)
	TextFrame:SetFont( STANDARD_TEXT_FONT, NAS.FontSize)
end)

-- Clear Button
me.ClearButton = CreateFrame( "Button", "NAlertLogClearButton", me, "UIPanelButtonTemplate" )
me.ClearButton:SetPoint("CENTER", me, "BOTTOM", -85, 25)
me.ClearButton:SetSize( 150, 25)
me.ClearButton:SetText("Clear Log")
me.ClearButton:SetScript("OnClick", function(self, button, down)
	if button ~= "LeftButton" then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	TextFrame:Clear()
end)

-- Cancel Button
me.HideButton = CreateFrame( "Button", "NAlertLogHideButton", me, "UIPanelButtonTemplate" )
me.HideButton:SetPoint("CENTER", me, "BOTTOM", 85, 25)
me.HideButton:SetSize( 150, 25)
me.HideButton:SetText("Hide Log")
me.HideButton:SetScript("OnClick", function(self, button, down)
	if button ~= "LeftButton" then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	NAlert.LogShown = false
end)

--me:SetScript("OnUpdate", function(self, elapsed)
--end)

-- Title region
me.TitleRegion = me:CreateTitleRegion()
me.TitleRegion:SetSize( 324, 64)
me.TitleRegion:SetPoint( "TOP", me, "TOP", 0,12)

-- Title frame header
me.TitleBkgnd=me:CreateTexture(nil , "ARTWORK")
me.TitleBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
me.TitleBkgnd:SetSize( 324, 64)
me.TitleBkgnd:SetPoint( "TOP", me, "TOP", 0,12)

-- Title frame text
me.Title = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
me.Title:SetText("Nick Alert Log Frame")
me.Title:SetPoint( "CENTER", me.TitleBkgnd, "CENTER", 0, 12 )
me.Title:SetJustifyH( "CENTER" )
me.Title:SetJustifyV( "MIDDLE" )
